Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp	(revision 107264)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp	(revision 107265)
@@ -47,4 +47,5 @@
 #include "UIMessageCenter.h"
 #include "UINotificationCenter.h"
+#include "UISlidingAnimation.h"
 #include "UITabBar.h"
 #include "UIToolPaneGlobal.h"
@@ -448,5 +449,5 @@
         m_pStackedWidget->setCurrentWidget(m_pPaneToolsGlobal); // rendering w/a
         m_pStackedWidget->setCurrentWidget(m_pSlidingAnimation);
-        m_pSlidingAnimation->animate(SlidingDirection_Reverse);
+        m_pSlidingAnimation->animate(false /* forward? */);
         return;
     }
@@ -461,5 +462,5 @@
         m_pStackedWidget->setCurrentWidget(m_pPaneToolsMachine); // rendering w/a
         m_pStackedWidget->setCurrentWidget(m_pSlidingAnimation);
-        m_pSlidingAnimation->animate(SlidingDirection_Forward);
+        m_pSlidingAnimation->animate(true /* forward? */);
         return;
     }
@@ -500,29 +501,24 @@
 }
 
-void UIVirtualBoxManagerWidget::sltHandleSlidingAnimationComplete(SlidingDirection enmDirection)
+void UIVirtualBoxManagerWidget::sltHandleSlidingAnimationComplete(bool fForward)
 {
     /* First switch the panes: */
-    switch (enmDirection)
-    {
-        case SlidingDirection_Forward:
-        {
-            /* Switch stacked widget to machine tool pane: */
-            m_pStackedWidget->setCurrentWidget(m_pPaneToolsMachine);
-            m_pPaneToolsGlobal->setActive(false);
-            m_pPaneToolsMachine->setActive(true);
-            /* Handle current tool type change: */
-            handleCurrentToolTypeChange(m_pMenuToolsMachine->toolsType());
-            break;
-        }
-        case SlidingDirection_Reverse:
-        {
-            /* Switch stacked widget to global tool pane: */
-            m_pStackedWidget->setCurrentWidget(m_pPaneToolsGlobal);
-            m_pPaneToolsMachine->setActive(false);
-            m_pPaneToolsGlobal->setActive(true);
-            /* Handle current tool type change: */
-            handleCurrentToolTypeChange(m_pMenuToolsGlobal->toolsType());
-            break;
-        }
+    if (fForward)
+    {
+        /* Switch stacked widget to machine tool pane: */
+        m_pStackedWidget->setCurrentWidget(m_pPaneToolsMachine);
+        m_pPaneToolsGlobal->setActive(false);
+        m_pPaneToolsMachine->setActive(true);
+        /* Handle current tool type change: */
+        handleCurrentToolTypeChange(m_pMenuToolsMachine->toolsType());
+    }
+    else
+    {
+        /* Switch stacked widget to global tool pane: */
+        m_pStackedWidget->setCurrentWidget(m_pPaneToolsGlobal);
+        m_pPaneToolsMachine->setActive(false);
+        m_pPaneToolsGlobal->setActive(true);
+        /* Handle current tool type change: */
+        handleCurrentToolTypeChange(m_pMenuToolsGlobal->toolsType());
     }
     /* Then handle current item change (again!): */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.h	(revision 107264)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.h	(revision 107265)
@@ -38,5 +38,4 @@
 /* GUI includes: */
 #include "UIExtraDataDefs.h"
-#include "UISlidingAnimation.h"
 
 /* Forward declarations: */
@@ -47,4 +46,5 @@
 class UIActionPool;
 class UIChooser;
+class UISlidingAnimation;
 class UITabBar;
 class UIToolPaneGlobal;
@@ -309,7 +309,6 @@
         void sltHandleChooserPaneSelectionInvalidated() { recacheCurrentMachineItemInformation(true /* fDontRaiseErrorPane */); }
 
-        /** Handles sliding animation complete signal.
-          * @param  enmDirection  Brings which direction was animation finished for. */
-        void sltHandleSlidingAnimationComplete(SlidingDirection enmDirection);
+        /** Handles @a fForward sliding animation complete signal. */
+        void sltHandleSlidingAnimationComplete(bool fForward);
 
         /** Handles state change for cloud profile with certain @a strProviderShortName and @a strProfileName. */
Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/UISlidingAnimation.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/UISlidingAnimation.cpp	(revision 107264)
+++ trunk/src/VBox/Frontends/VirtualBox/src/widgets/UISlidingAnimation.cpp	(revision 107265)
@@ -60,5 +60,5 @@
 }
 
-void UISlidingAnimation::animate(SlidingDirection enmDirection)
+void UISlidingAnimation::animate(bool fForward)
 {
     /* Mark animation started: */
@@ -100,18 +100,13 @@
 
     /* Update initial widget geometry: */
-    switch (enmDirection)
+    if (fForward)
     {
-        case SlidingDirection_Forward:
-        {
-            setWidgetGeometry(m_startWidgetGeometry);
-            emit sigForward();
-            break;
-        }
-        case SlidingDirection_Reverse:
-        {
-            setWidgetGeometry(m_finalWidgetGeometry);
-            emit sigReverse();
-            break;
-        }
+        setWidgetGeometry(m_startWidgetGeometry);
+        emit sigForward();
+    }
+    else
+    {
+        setWidgetGeometry(m_finalWidgetGeometry);
+        emit sigReverse();
     }
 }
@@ -125,5 +120,5 @@
         m_fIsInProgress = false;
         /* And notify listeners: */
-        emit sigAnimationComplete(SlidingDirection_Reverse);
+        emit sigAnimationComplete(false /* forward? */);
     }
 }
@@ -137,5 +132,5 @@
         m_fIsInProgress = false;
         /* And notify listeners: */
-        emit sigAnimationComplete(SlidingDirection_Forward);
+        emit sigAnimationComplete(true /* forward? */);
     }
 }
Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/UISlidingAnimation.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/UISlidingAnimation.h	(revision 107264)
+++ trunk/src/VBox/Frontends/VirtualBox/src/widgets/UISlidingAnimation.h	(revision 107265)
@@ -42,12 +42,4 @@
 
 
-/** Sliding direction. */
-enum SlidingDirection
-{
-    SlidingDirection_Forward,
-    SlidingDirection_Reverse
-};
-
-
 /** QWidget extension which renders a sliding animation
   * while transiting from one widget to another. */
@@ -66,6 +58,6 @@
     void sigReverse();
 
-    /** Notifies listeners about animation in specified @a enmDirection is complete. */
-    void sigAnimationComplete(SlidingDirection enmDirection);
+    /** Notifies listeners about @a fForward animation is complete. */
+    void sigAnimationComplete(bool fForward);
 
 public:
@@ -79,6 +71,6 @@
     void setWidgets(QWidget *pWidget1, QWidget *pWidget2);
 
-    /** Animates cached pWidget1 and pWidget2 in passed @a enmDirection. */
-    void animate(SlidingDirection enmDirection);
+    /** Animates cached pWidget1 and pWidget2 in @a fForward direction. */
+    void animate(bool fForward);
 
 private slots: