Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp	(revision 107265)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp	(revision 107266)
@@ -95,220 +95,4 @@
 }
 
-UIVirtualMachineItem *UIVirtualBoxManagerWidget::currentItem() const
-{
-    return m_pPaneChooser->currentItem();
-}
-
-QList<UIVirtualMachineItem*> UIVirtualBoxManagerWidget::currentItems() const
-{
-    return m_pPaneChooser->currentItems();
-}
-
-bool UIVirtualBoxManagerWidget::isGroupItemSelected() const
-{
-    return m_pPaneChooser->isGroupItemSelected();
-}
-
-bool UIVirtualBoxManagerWidget::isGlobalItemSelected() const
-{
-    return m_pPaneChooser->isGlobalItemSelected();
-}
-
-bool UIVirtualBoxManagerWidget::isMachineItemSelected() const
-{
-    return m_pPaneChooser->isMachineItemSelected();
-}
-
-bool UIVirtualBoxManagerWidget::isLocalMachineItemSelected() const
-{
-    return m_pPaneChooser->isLocalMachineItemSelected();
-}
-
-bool UIVirtualBoxManagerWidget::isCloudMachineItemSelected() const
-{
-    return m_pPaneChooser->isCloudMachineItemSelected();
-}
-
-bool UIVirtualBoxManagerWidget::isSingleGroupSelected() const
-{
-    return m_pPaneChooser->isSingleGroupSelected();
-}
-
-bool UIVirtualBoxManagerWidget::isSingleLocalGroupSelected() const
-{
-    return m_pPaneChooser->isSingleLocalGroupSelected();
-}
-
-bool UIVirtualBoxManagerWidget::isSingleCloudProviderGroupSelected() const
-{
-    return m_pPaneChooser->isSingleCloudProviderGroupSelected();
-}
-
-bool UIVirtualBoxManagerWidget::isSingleCloudProfileGroupSelected() const
-{
-    return m_pPaneChooser->isSingleCloudProfileGroupSelected();
-}
-
-bool UIVirtualBoxManagerWidget::isAllItemsOfOneGroupSelected() const
-{
-    return m_pPaneChooser->isAllItemsOfOneGroupSelected();
-}
-
-QString UIVirtualBoxManagerWidget::fullGroupName() const
-{
-    return m_pPaneChooser->fullGroupName();
-}
-
-bool UIVirtualBoxManagerWidget::isGroupSavingInProgress() const
-{
-    return m_pPaneChooser->isGroupSavingInProgress();
-}
-
-bool UIVirtualBoxManagerWidget::isCloudProfileUpdateInProgress() const
-{
-    return m_pPaneChooser->isCloudProfileUpdateInProgress();
-}
-
-void UIVirtualBoxManagerWidget::switchToGlobalItem()
-{
-    AssertPtrReturnVoid(m_pPaneChooser);
-    m_pPaneChooser->setCurrentGlobal();
-}
-
-void UIVirtualBoxManagerWidget::openGroupNameEditor()
-{
-    m_pPaneChooser->openGroupNameEditor();
-}
-
-void UIVirtualBoxManagerWidget::disbandGroup()
-{
-    m_pPaneChooser->disbandGroup();
-}
-
-void UIVirtualBoxManagerWidget::removeMachine()
-{
-    m_pPaneChooser->removeMachine();
-}
-
-void UIVirtualBoxManagerWidget::moveMachineToGroup(const QString &strName /* = QString() */)
-{
-    m_pPaneChooser->moveMachineToGroup(strName);
-}
-
-QStringList UIVirtualBoxManagerWidget::possibleGroupsForMachineToMove(const QUuid &uId)
-{
-    return m_pPaneChooser->possibleGroupsForMachineToMove(uId);
-}
-
-QStringList UIVirtualBoxManagerWidget::possibleGroupsForGroupToMove(const QString &strFullName)
-{
-    return m_pPaneChooser->possibleGroupsForGroupToMove(strFullName);
-}
-
-void UIVirtualBoxManagerWidget::refreshMachine()
-{
-    m_pPaneChooser->refreshMachine();
-}
-
-void UIVirtualBoxManagerWidget::sortGroup()
-{
-    m_pPaneChooser->sortGroup();
-}
-
-void UIVirtualBoxManagerWidget::setMachineSearchWidgetVisibility(bool fVisible)
-{
-    m_pPaneChooser->setMachineSearchWidgetVisibility(fVisible);
-}
-
-void UIVirtualBoxManagerWidget::setToolsTypeGlobal(UIToolType enmType)
-{
-    m_pMenuToolsGlobal->setToolsType(enmType);
-}
-
-UIToolType UIVirtualBoxManagerWidget::toolsTypeGlobal() const
-{
-    return m_pMenuToolsGlobal ? m_pMenuToolsGlobal->toolsType() : UIToolType_Invalid;
-}
-
-void UIVirtualBoxManagerWidget::setToolsTypeMachine(UIToolType enmType)
-{
-    m_pMenuToolsMachine->setToolsType(enmType);
-}
-
-UIToolType UIVirtualBoxManagerWidget::toolsTypeMachine() const
-{
-    return m_pMenuToolsMachine ? m_pMenuToolsMachine->toolsType() : UIToolType_Invalid;
-}
-
-UIToolType UIVirtualBoxManagerWidget::currentGlobalTool() const
-{
-    return m_pPaneToolsGlobal ? m_pPaneToolsGlobal->currentTool() : UIToolType_Invalid;
-}
-
-UIToolType UIVirtualBoxManagerWidget::currentMachineTool() const
-{
-    return m_pPaneToolsMachine ? m_pPaneToolsMachine->currentTool() : UIToolType_Invalid;
-}
-
-bool UIVirtualBoxManagerWidget::isGlobalToolOpened(UIToolType enmType) const
-{
-    return m_pPaneToolsGlobal ? m_pPaneToolsGlobal->isToolOpened(enmType) : false;
-}
-
-bool UIVirtualBoxManagerWidget::isMachineToolOpened(UIToolType enmType) const
-{
-    return m_pPaneToolsMachine ? m_pPaneToolsMachine->isToolOpened(enmType) : false;
-}
-
-void UIVirtualBoxManagerWidget::switchGlobalToolTo(UIToolType enmType)
-{
-    /* Open corresponding tool: */
-    m_pPaneToolsGlobal->openTool(enmType);
-
-    /* Let the parent know: */
-    emit sigToolTypeChangeGlobal();
-
-    /* Update toolbar: */
-    updateToolbar();
-
-    /* Handle current tool type change: */
-    handleCurrentToolTypeChange(enmType);
-}
-
-void UIVirtualBoxManagerWidget::switchMachineToolTo(UIToolType enmType)
-{
-    /* Open corresponding tool: */
-    m_pPaneToolsMachine->openTool(enmType);
-
-    /* Let the parent know: */
-    emit sigToolTypeChangeMachine();
-
-    /* Update toolbar: */
-    updateToolbar();
-
-    /* Handle current tool type change: */
-    handleCurrentToolTypeChange(enmType);
-}
-
-void UIVirtualBoxManagerWidget::closeGlobalTool(UIToolType enmType)
-{
-    m_pPaneToolsGlobal->closeTool(enmType);
-}
-
-void UIVirtualBoxManagerWidget::closeMachineTool(UIToolType enmType)
-{
-    m_pPaneToolsMachine->closeTool(enmType);
-}
-
-bool UIVirtualBoxManagerWidget::isCurrentStateItemSelected() const
-{
-    return m_pPaneToolsMachine->isCurrentStateItemSelected();
-}
-
-QUuid UIVirtualBoxManagerWidget::currentSnapshotId()
-{
-    return m_pPaneToolsMachine->currentSnapshotId();
-}
-
 void UIVirtualBoxManagerWidget::updateToolBarMenuButtons(bool fSeparateMenuSection)
 {
@@ -316,4 +100,220 @@
     if (pButton)
         pButton->setPopupMode(fSeparateMenuSection ? QToolButton::MenuButtonPopup : QToolButton::DelayedPopup);
+}
+
+UIVirtualMachineItem *UIVirtualBoxManagerWidget::currentItem() const
+{
+    return m_pPaneChooser->currentItem();
+}
+
+QList<UIVirtualMachineItem*> UIVirtualBoxManagerWidget::currentItems() const
+{
+    return m_pPaneChooser->currentItems();
+}
+
+bool UIVirtualBoxManagerWidget::isGroupItemSelected() const
+{
+    return m_pPaneChooser->isGroupItemSelected();
+}
+
+bool UIVirtualBoxManagerWidget::isGlobalItemSelected() const
+{
+    return m_pPaneChooser->isGlobalItemSelected();
+}
+
+bool UIVirtualBoxManagerWidget::isMachineItemSelected() const
+{
+    return m_pPaneChooser->isMachineItemSelected();
+}
+
+bool UIVirtualBoxManagerWidget::isLocalMachineItemSelected() const
+{
+    return m_pPaneChooser->isLocalMachineItemSelected();
+}
+
+bool UIVirtualBoxManagerWidget::isCloudMachineItemSelected() const
+{
+    return m_pPaneChooser->isCloudMachineItemSelected();
+}
+
+bool UIVirtualBoxManagerWidget::isSingleGroupSelected() const
+{
+    return m_pPaneChooser->isSingleGroupSelected();
+}
+
+bool UIVirtualBoxManagerWidget::isSingleLocalGroupSelected() const
+{
+    return m_pPaneChooser->isSingleLocalGroupSelected();
+}
+
+bool UIVirtualBoxManagerWidget::isSingleCloudProviderGroupSelected() const
+{
+    return m_pPaneChooser->isSingleCloudProviderGroupSelected();
+}
+
+bool UIVirtualBoxManagerWidget::isSingleCloudProfileGroupSelected() const
+{
+    return m_pPaneChooser->isSingleCloudProfileGroupSelected();
+}
+
+bool UIVirtualBoxManagerWidget::isAllItemsOfOneGroupSelected() const
+{
+    return m_pPaneChooser->isAllItemsOfOneGroupSelected();
+}
+
+QString UIVirtualBoxManagerWidget::fullGroupName() const
+{
+    return m_pPaneChooser->fullGroupName();
+}
+
+bool UIVirtualBoxManagerWidget::isGroupSavingInProgress() const
+{
+    return m_pPaneChooser->isGroupSavingInProgress();
+}
+
+bool UIVirtualBoxManagerWidget::isCloudProfileUpdateInProgress() const
+{
+    return m_pPaneChooser->isCloudProfileUpdateInProgress();
+}
+
+void UIVirtualBoxManagerWidget::switchToGlobalItem()
+{
+    AssertPtrReturnVoid(m_pPaneChooser);
+    m_pPaneChooser->setCurrentGlobal();
+}
+
+void UIVirtualBoxManagerWidget::openGroupNameEditor()
+{
+    m_pPaneChooser->openGroupNameEditor();
+}
+
+void UIVirtualBoxManagerWidget::disbandGroup()
+{
+    m_pPaneChooser->disbandGroup();
+}
+
+void UIVirtualBoxManagerWidget::removeMachine()
+{
+    m_pPaneChooser->removeMachine();
+}
+
+void UIVirtualBoxManagerWidget::moveMachineToGroup(const QString &strName /* = QString() */)
+{
+    m_pPaneChooser->moveMachineToGroup(strName);
+}
+
+QStringList UIVirtualBoxManagerWidget::possibleGroupsForMachineToMove(const QUuid &uId)
+{
+    return m_pPaneChooser->possibleGroupsForMachineToMove(uId);
+}
+
+QStringList UIVirtualBoxManagerWidget::possibleGroupsForGroupToMove(const QString &strFullName)
+{
+    return m_pPaneChooser->possibleGroupsForGroupToMove(strFullName);
+}
+
+void UIVirtualBoxManagerWidget::refreshMachine()
+{
+    m_pPaneChooser->refreshMachine();
+}
+
+void UIVirtualBoxManagerWidget::sortGroup()
+{
+    m_pPaneChooser->sortGroup();
+}
+
+void UIVirtualBoxManagerWidget::setMachineSearchWidgetVisibility(bool fVisible)
+{
+    m_pPaneChooser->setMachineSearchWidgetVisibility(fVisible);
+}
+
+void UIVirtualBoxManagerWidget::setToolsTypeGlobal(UIToolType enmType)
+{
+    m_pMenuToolsGlobal->setToolsType(enmType);
+}
+
+UIToolType UIVirtualBoxManagerWidget::toolsTypeGlobal() const
+{
+    return m_pMenuToolsGlobal ? m_pMenuToolsGlobal->toolsType() : UIToolType_Invalid;
+}
+
+void UIVirtualBoxManagerWidget::setToolsTypeMachine(UIToolType enmType)
+{
+    m_pMenuToolsMachine->setToolsType(enmType);
+}
+
+UIToolType UIVirtualBoxManagerWidget::toolsTypeMachine() const
+{
+    return m_pMenuToolsMachine ? m_pMenuToolsMachine->toolsType() : UIToolType_Invalid;
+}
+
+UIToolType UIVirtualBoxManagerWidget::currentGlobalTool() const
+{
+    return m_pPaneToolsGlobal ? m_pPaneToolsGlobal->currentTool() : UIToolType_Invalid;
+}
+
+UIToolType UIVirtualBoxManagerWidget::currentMachineTool() const
+{
+    return m_pPaneToolsMachine ? m_pPaneToolsMachine->currentTool() : UIToolType_Invalid;
+}
+
+bool UIVirtualBoxManagerWidget::isGlobalToolOpened(UIToolType enmType) const
+{
+    return m_pPaneToolsGlobal ? m_pPaneToolsGlobal->isToolOpened(enmType) : false;
+}
+
+bool UIVirtualBoxManagerWidget::isMachineToolOpened(UIToolType enmType) const
+{
+    return m_pPaneToolsMachine ? m_pPaneToolsMachine->isToolOpened(enmType) : false;
+}
+
+void UIVirtualBoxManagerWidget::switchGlobalToolTo(UIToolType enmType)
+{
+    /* Open corresponding tool: */
+    m_pPaneToolsGlobal->openTool(enmType);
+
+    /* Let the parent know: */
+    emit sigToolTypeChangeGlobal();
+
+    /* Update toolbar: */
+    updateToolbar();
+
+    /* Handle current tool type change: */
+    handleCurrentToolTypeChange(enmType);
+}
+
+void UIVirtualBoxManagerWidget::switchMachineToolTo(UIToolType enmType)
+{
+    /* Open corresponding tool: */
+    m_pPaneToolsMachine->openTool(enmType);
+
+    /* Let the parent know: */
+    emit sigToolTypeChangeMachine();
+
+    /* Update toolbar: */
+    updateToolbar();
+
+    /* Handle current tool type change: */
+    handleCurrentToolTypeChange(enmType);
+}
+
+void UIVirtualBoxManagerWidget::closeGlobalTool(UIToolType enmType)
+{
+    m_pPaneToolsGlobal->closeTool(enmType);
+}
+
+void UIVirtualBoxManagerWidget::closeMachineTool(UIToolType enmType)
+{
+    m_pPaneToolsMachine->closeTool(enmType);
+}
+
+bool UIVirtualBoxManagerWidget::isCurrentStateItemSelected() const
+{
+    return m_pPaneToolsMachine->isCurrentStateItemSelected();
+}
+
+QUuid UIVirtualBoxManagerWidget::currentSnapshotId()
+{
+    return m_pPaneToolsMachine->currentSnapshotId();
 }
 
@@ -1051,7 +1051,7 @@
             case UIToolType_FileManager:
             {
-                m_pToolBar->addAction(m_pActionPool->action(UIActionIndex_M_FileManager_T_Preferences));
-                m_pToolBar->addAction(m_pActionPool->action(UIActionIndex_M_FileManager_T_Operations));
-                m_pToolBar->addAction(m_pActionPool->action(UIActionIndex_M_FileManager_T_Log));
+                m_pToolBar->addAction(actionPool()->action(UIActionIndex_M_FileManager_T_Preferences));
+                m_pToolBar->addAction(actionPool()->action(UIActionIndex_M_FileManager_T_Operations));
+                m_pToolBar->addAction(actionPool()->action(UIActionIndex_M_FileManager_T_Log));
                 m_pToolBar->addSeparator();
                 m_pToolBar->addAction(actionPool()->action(UIActionIndexMN_M_Machine_S_Settings));
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.h	(revision 107265)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.h	(revision 107266)
@@ -47,5 +47,4 @@
 class UIChooser;
 class UISlidingAnimation;
-class UITabBar;
 class UIToolPaneGlobal;
 class UIToolPaneMachine;
@@ -141,4 +140,10 @@
         /** Returns the action-pool instance. */
         UIActionPool *actionPool() const { return m_pActionPool; }
+    /** @} */
+
+    /** @name Tool-bar stuff.
+      * @{ */
+        /** Updates tool-bar menu buttons. */
+        void updateToolBarMenuButtons(bool fSeparateMenuSection);
     /** @} */
 
@@ -241,10 +246,4 @@
     /** @} */
 
-    /** @name Tool-bar stuff.
-      * @{ */
-        /** Updates tool-bar menu buttons. */
-        void updateToolBarMenuButtons(bool fSeparateMenuSection);
-    /** @} */
-
     /** @name Help browser stuff.
       * @{ */