Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp	(revision 107283)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp	(revision 107284)
@@ -399,5 +399,5 @@
 }
 
-void UIVirtualBoxManagerWidget::sltHandleStateChange(const QUuid &uId)
+void UIVirtualBoxManagerWidget::sltHandleMachineStateChange(const QUuid &uId)
 {
     // WORKAROUND:
@@ -503,7 +503,6 @@
     recacheCurrentMachineItemInformation();
 
-    /* Calculate new selection type: */
+    /* Calculate new selection type and item accessibility status: */
     const SelectionType enmSelectedItemType = selectionType();
-    /* Calculate new item accessibility status: */
     const bool fCurrentItemIsOk = isItemAccessible();
 
@@ -557,43 +556,43 @@
 {
     /* Not for global items: */
-    if (!isGlobalItemSelected())
-    {
-        /* Acquire current item: */
-        UIVirtualMachineItem *pItem = currentItem();
-        const bool fCurrentItemIsOk = isItemAccessible(pItem);
-
-        /* If current item is Ok: */
-        if (fCurrentItemIsOk)
+    if (isGlobalItemSelected())
+        return;
+
+    /* Acquire current item: */
+    UIVirtualMachineItem *pItem = currentItem();
+    const bool fCurrentItemIsOk = isItemAccessible(pItem);
+
+    /* If current item is Ok: */
+    if (fCurrentItemIsOk)
+    {
+        /* If Error-pane is chosen currently => switch to tool currently chosen in Tools-menu: */
+        if (m_pPaneToolsMachine->currentTool() == UIToolType_Error)
+            switchMachineToolTo(m_pMenuToolsMachine->toolsType());
+
+        /* If we still have same item selected: */
+        if (pItem && pItem->id() == uId)
         {
-            /* If Error-pane is chosen currently => switch to tool currently chosen in Tools-menu: */
-            if (m_pPaneToolsMachine->currentTool() == UIToolType_Error)
-                switchMachineToolTo(m_pMenuToolsMachine->toolsType());
-
-            /* If we still have same item selected: */
-            if (pItem && pItem->id() == uId)
-            {
-                /* Propagate current items to update the Details-pane: */
-                m_pPaneToolsMachine->setItems(currentItems());
-            }
+            /* Propagate current items to update the Details-pane: */
+            m_pPaneToolsMachine->setItems(currentItems());
         }
-        else
+    }
+    else
+    {
+        /* Make sure Error pane raised: */
+        if (m_pPaneToolsMachine->currentTool() != UIToolType_Error)
+            m_pPaneToolsMachine->openTool(UIToolType_Error);
+
+        /* If we still have same item selected: */
+        if (pItem && pItem->id() == uId)
         {
-            /* Make sure Error pane raised: */
-            if (m_pPaneToolsMachine->currentTool() != UIToolType_Error)
-                m_pPaneToolsMachine->openTool(UIToolType_Error);
-
-            /* If we still have same item selected: */
-            if (pItem && pItem->id() == uId)
-            {
-                /* Propagate current items to update the Details-pane (in any case): */
-                m_pPaneToolsMachine->setItems(currentItems());
-                /* Propagate last access error to update the Error-pane (if machine selected but inaccessible): */
-                m_pPaneToolsMachine->setErrorDetails(pItem->accessError());
-            }
+            /* Propagate current items to update the Details-pane (in any case): */
+            m_pPaneToolsMachine->setItems(currentItems());
+            /* Propagate last access error to update the Error-pane (if machine selected but inaccessible): */
+            m_pPaneToolsMachine->setErrorDetails(pItem->accessError());
         }
-
-        /* Pass the signal further: */
-        emit sigCloudMachineStateChange(uId);
-    }
+    }
+
+    /* Pass the signal further: */
+    emit sigCloudMachineStateChange(uId);
 }
 
@@ -828,5 +827,5 @@
     /* Global VBox event handlers: */
     connect(gVBoxEvents, &UIVirtualBoxEventHandler::sigMachineStateChange,
-            this, &UIVirtualBoxManagerWidget::sltHandleStateChange);
+            this, &UIVirtualBoxManagerWidget::sltHandleMachineStateChange);
 
     /* Global VBox extra-data event handlers: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.h	(revision 107283)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.h	(revision 107284)
@@ -281,5 +281,5 @@
       * @{ */
         /** Handles CVirtualBox event about state change for machine with @a uId. */
-        void sltHandleStateChange(const QUuid &uId);
+        void sltHandleMachineStateChange(const QUuid &uId);
     /** @} */
 
@@ -364,13 +364,10 @@
     /** @} */
 
-    /** @name Common stuff.
+    /** @name Tools stuff.
       * @{ */
         /** Recaches current machine item information.
           * @param  fDontRaiseErrorPane  Brings whether we should not raise error-pane. */
         void recacheCurrentMachineItemInformation(bool fDontRaiseErrorPane = false);
-    /** @} */
-
-    /** @name Tools stuff.
-      * @{ */
+
         /** Updates Global tools menu. */
         void updateToolsMenuGlobal();